﻿/****************************************************************************
 *   FileName    : mainmenu_sample.as
 *   Language    : Flash ActionScript 2.0
 *   Date        : 2011.04.21
 *   Author      : Cowon Systems, Inc.
 *   Description : Sample code for C2
 ****************************************************************************
 *
 *   Copyright (c) Cowon Systems, Inc.
 *   ALL RIGHTS RESERVED
 *
  ****************************************************************************/

// Global variable for fscommand
var tempString:String;

var currentPage:Number				= 0;

// Widget
var AnimationFunction:Function;
var widgetIndex:Number				= -1;

// Mouse Event
var isStarting:Boolean				= false;
var movingPage:Boolean				= false;
var mouseTouch:Boolean				= false;
var mouseListener:Object			= new Object();

var limitTop:Number					= 120;
var limitBottom:Number				= -(4 * _global.LCD_HEIGHT) + (_global.LCD_HEIGHT >> 1);

var limitLeft:Number				= (_global.LCD_WIDTH * 3) >> 1;
var limitRight:Number				= _global.LCD_WIDTH >> 1;

var mcCon:MovieClip					= _root.MCCon;
var mcTimeWidget:MovieClip			= _root.MCCon.MCDateIcon;

// Constant values
var TOTALICONS:Number				= 14;
var TOTALOPTIONALICONS:Number		=  5;

var DMB:Number						=  5;

var MAXPAGE:Number					=  2;
var MAXWIDGETS:Number			=  7;

var NEXT:Number						=  1;
var PREV:Number						= -1;


function ExecuteSubMenu(iconIndex:Number):Void {
	var modeArray:Array = new Array(MODE_MUSIC, MODE_VIDEO, MODE_RADIO, MODE_PICTURE, MODE_TEXT, MODE_DMB, MODE_BROWSER, MODE_FLASHBROWSER,
									MODE_RECORD, MODE_SETTING, "Calculator.swf", "Typist.swf", "Stopwatch.swf", "Notepad.swf");

	if(isNaN(modeArray[iconIndex]))		_global.LoadSWF(_global.MODE_ETC, modeArray[iconIndex]);
	else 								_global.LoadSWF(Number(modeArray[iconIndex]));
}

function ExecuteOptionalMenu(iconIndex:Number):Void {
	switch(iconIndex) {
		case 0:
		case 1:
			ext_fscommand2("SetSysOffFlag", (iconIndex + 1));
			break;

		case 2:
			ext_fscommand2("EtcUsrSetMainmenu", 1);
			_global.LoadSWF(_global.MODE_MAIN);
			break;

		case 3:
			var displayBrightness:Number = ext_fscommand2("GetDisBrightness") + 1;

			if(ext_fscommand2("SetDisBrightness", displayBrightness) == -1) {
				displayBrightness = 0;
				ext_fscommand2("SetDisBrightness", displayBrightness);
			}
			UpdateLCDBrightness();
			mcCon.MCSelect._visible = false;
			break;

		case 4:
			var displayRotation:Number = ext_fscommand2("GetSysDisplayRotation");

			if(displayRotation != -1) {
				displayRotation ^= 1;
				ext_fscommand2("SetSysDisplayRotation", displayRotation);
			}
			mcCon.MCSelect._visible = false;
			break;
	}
}


function MovePage(direction:Number, acceleration:Number):Void {
	var diff:Number;
	var step:Number = 0;
	var targetPosition:Number;
						// Move Page
	currentPage += direction;
	if((currentPage < 0) || (currentPage >= MAXPAGE)) {
		currentPage -= direction;
	}
	targetPosition = -(currentPage * _global.LCD_HEIGHT) + (_global.LCD_HEIGHT >> 1);

	     if(acceleration > 0.7)			acceleration = 0.9;
	else if(acceleration < 0.3)			acceleration = 0.3;
	else if(acceleration == undefined)	step = 0;

	movingPage = true;

	mcCon.onEnterFrame = function(Void):Void {
		if(mouseTouch == true) delete this.onEnterFrame;

		diff = targetPosition - this._y;

		if((Math.abs(diff) > 3) && (acceleration != undefined)) {
			this._y += int(diff * acceleration);
		}
		else if(step == 0) {
			this._y = targetPosition;

			step = 1;
		}
		else {
			movingPage = false;
			isStarting = false;
			delete this.onEnterFrame;
		}
	}
}

function RemoveMouseEvents(Void):Void {
	delete mouseListener.onMouseDown;
	delete mouseListener.onMouseMove;
	delete mouseListener.onMouseUp;

	Mouse.removeListener(mouseListener);
}

function InitializeMouseEvents(Void):Void {
	var startY:Number;
	var newStartY:Number;
	var startTime:Number;
	var counter:Number;
	var direction:Number;
	var intervalY:Number;
	var initYPosition:Number;
	var initPage:Number;
	var dragFlag:Boolean;
	var touchBoundary:Number;

	RemoveMouseEvents();

	mouseListener.onMouseDown = function(Void):Void {
		if(isStarting == true) return;

		startY = newStartY = _root._ymouse;

		mouseTouch = true;

		touchBoundary = 15;
		if(mcCon.onEnterFrame != undefined) {
			dragFlag = true;
			delete mcCon.onEnterFrame;
		}

		initYPosition = int(mcCon._y);

		initPage = currentPage;

		this.onMouseMove = function(Void):Void {
			intervalY = int(_root._ymouse - startY);

			if(dragFlag == true) {
				if(((mcCon._y >= limitTop) && (intervalY > 0)) || ((mcCon._y <= limitBottom) && (intervalY < 0)))
					intervalY = int(intervalY >> 1);

				if((intervalY / direction) < 0)	{
					direction *= -1;
					counter = 1;
					startTime = getTimer();
					newStartY = _root._ymouse;
				}
				else {
					if(Math.abs(intervalY) < 5) {
						counter++;
						newStartY = _root._ymouse;
					}
					else if(counter != 0) {
						counter = 0;
						startTime = getTimer();
					}
				}
				mcCon._y = initYPosition + intervalY;
			}
			else if((Math.abs(intervalY) > touchBoundary) || (Math.abs(intervalX) > touchBoundary)) {
				mcCon.MCSelect._visible = false;
				mcStage["MCIcon" + selectedItem].onDragOut();
				mcCon.MCPictureWidget.onDragOut();
				selectedItem = -1;

				if(intervalY < 0)	direction = -1;
				else				direction =  1;

				startY = newStartY = int(_root._ymouse);

				touchBoundary = 0;

				dragFlag = true;
				counter = 0;

				startTime = getTimer();
			}
		}
	}

	mouseListener.onMouseUp = function(Void):Void {
		delete this.onMouseMove;
		if(isStarting == true) return;

		if(movingPage == false) {
			if((dragFlag != true) || (selectedItem != -1)) return;
		}

		dragFlag = false;
		mouseTouch = false;

		var acceleration:Number;
		var intervalTime:Number = (getTimer() - startTime) * 1.6;

		acceleration = Math.abs(intervalY / intervalTime) + 0.16;
		if(Math.abs(intervalY) > 45) acceleration = Math.max(acceleration, 0.5);

		direction = initYPosition - mcCon._y;

		if((acceleration < 0.3) || (((direction < 0) && (currentPage == 0)) || ((direction > 0) && (currentPage == (MAXPAGE - 1))))) {
			movingPage = true;

			if(acceleration > 0.4) {
				acceleration = 0.5;

				if(currentPage == (MAXPAGE - 1))	currentPage = 0;
				else								currentPage = MAXPAGE - 1;
			}
			else {
				acceleration = Math.max(Math.min(acceleration, 0.5), 0.3);
			}

			initYPosition = -(currentPage * _global.LCD_HEIGHT) + (_global.LCD_HEIGHT >> 1);
			mcCon.onEnterFrame = function(Void):Void {
				if(mouseTouch == true) delete this.onEnterFrame;

				intervalY = initYPosition - this._y;

				if(Math.abs(intervalY) > 3) {
					this._y += int(intervalY * acceleration);
				}
				else {
					delete this.onEnterFrame;
					this._y = initYPosition;
					movingPage = false;
				}
			}
		}
		else {
			if(intervalY < 0)	MovePage(NEXT, acceleration);
			else				MovePage(PREV, acceleration);
		}
	}

	Mouse.addListener(mouseListener);
}

function InitializeTimer(Void):Void {
	var tempHour:Number;
	var previousDay:Number		= -1;
	var previousMode:Number		= -1;
	var previousSecond:Number	= -1;
	var previousMinute:Number	= -1;
	var previousHour:Number		= -1;
	var display24Hour:Number	= ext_fscommand2("GetTim24HDisplay");

	if(mcTimeWidget.onEnterFrame != undefined) delete mcTimeWidget.onEnterFrame;

	mcTimeWidget.onEnterFrame = function(Void):Void {
		if(previousSecond != _global.g_curSec) {
			_global.CommonSetDigitMC(mcCon.MCWidget.MCTime.MCSecond, _global.g_curSec);

			if(previousMinute != _global.g_curMin) {
				if(previousHour != _global.g_curHour) {
					UpdateWidget();
					UpdateDate(previousDay);

					tempHour = _global.g_curHour;

					if(display24Hour == 0) {
						if(tempHour < 12) {
							mcCon.MCWidget.MCTime.MCAmPm.gotoAndStop(1);
						}
						else {
							mcCon.MCWidget.MCTime.MCAmPm.gotoAndStop(2);
							if(tempHour != 12) tempHour -= 12;
						}
					}

					_global.CommonSetDigitMC(mcCon.MCWidget.MCTime.MCHour, tempHour);

					previousHour = _global.g_curHour;
				}

				_global.CommonSetDigitMC(mcCon.MCWidget.MCTime.MCMinute, _global.g_curMin);

				previousMinute = _global.g_curMin;
			}

			previousSecond = _global.g_curSec;
		}

		AnimationFunction();
	}
}

function GenerateRandomPosition(maxLength:Number):Number {
	return int(Math.random() * maxLength);
}

function StartAnimation(Void):Void {
	switch(widgetIndex) {
		case 0:
			AnimationFunction = function(Void):Void {
				mcCon.MCWidget.MCRay0._rotation += 0.5;
				mcCon.MCWidget.MCRay1._rotation -= 0.5;
			}
			break;

		case 1:
			AnimationFunction = function(Void):Void {
				var idx:Number;
				var mcBubble:MovieClip;

				for(idx = 0; idx < 5; idx++) {
					mcBubble = mcCon.MCWidget["MCBubble" + String(idx)];
					mcBubble._y -= int(mcBubble._height / 5);

					if((mcBubble._y + mcBubble._height) < 0) {
						mcBubble._x = GenerateRandomPosition(_global.LCD_WIDTH);
						mcBubble._y = _global.LCD_HEIGHT;
					}
				}
			}
			break;

		case 2:
			AnimationFunction = function(Void):Void {
				var idx:Number;
				var mcBalloon:MovieClip;

				for(idx = 0; idx < 3; idx++) {
					mcBalloon = mcCon.MCWidget["MCBalloon" + String(idx)];
					mcBalloon._y--;

					if((mcBalloon._y + mcBalloon._height) < 0) {
						mcBalloon._x = GenerateRandomPosition(_global.LCD_WIDTH);
						mcBalloon._y = _global.LCD_HEIGHT;
					}
				}
				mcCon.MCWidget.MCWheel._rotation += 0.5;
			}
			break;

		case 3:
		case 4:
		case 5:
			// Nothing to do!
			AnimationFunction = null;
			break;
	}
}

function StartUpEffect(Void):Void {
	var delay:Number = 3;
	var targetY:Number = 120;
	var tmpCurrentPage:Number = currentPage;

	currentPage = 0;
	isStarting = true;
	if((_global.GetPrevLauncherMode() == -1) || (_global.GetPrevLauncherMode() == _global.MODE_MAIN)) {
		_root.MCCon._y = 240;

		_root.MCCon.onEnterFrame = function(Void):Void {
			if((--delay) < 0) {
				diff = targetY - this._y;

				if(Math.abs(diff) > 3) {
					this._y += (diff >> 1);
				}
				else {
					this._y = targetY;
					isStarting = false;
					_root.MCBackground._visible = true;
					delete this.onEnterFrame;
				}
			}
		}
	}
	else {
		MovePage(tmpCurrentPage, 0.9);
	}
}

function UpdateWidget(updateIdx:Number):Void {
	var tmpIndex:Number;

	if(updateIdx == undefined) {
		var timeRange:Array		= new Array(2, 6, 12, 16, 19, 22, 24);
		var widgetIndexArray:Array	= new Array(4, 5,  0,  1,  2,  3, 4);

		for(tmpIndex = 0; tmpIndex < timeRange.length; tmpIndex++) {
			if(_global.g_curHour < timeRange[tmpIndex]) break;
		}
		tmpIndex = widgetIndexArray[tmpIndex];
	}
	else {
		tmpIndex = updateIdx;
		widgetIndex = -1;
	}

	if(tmpIndex != widgetIndex) {
		var display24Hour:Number = ext_fscommand2("GetTim24HDisplay");

		if(mcCon.MCWidget != undefined) mcCon.MCWidget.removeMovieClip();
		mcCon.attachMovie(String("MCIntroWidget" + tmpIndex), "MCWidget", mcCon.getNextHighestDepth());
		mcCon.MCWidget._x = -160;
		mcCon.MCWidget._y = -120;

		RegisterChangeWidgetButton();

		mcCon.MCWidget.MCTime.MCAmPm._visible = (display24Hour == 0);
		mcCon.MCWidget.MCTime.MC12H.gotoAndStop(display24Hour + 1);

		widgetIndex = tmpIndex;
		mcCon.MCTermIcon.gotoAndStop(widgetIndex + 1);
		StartAnimation();
	}
}

function UpdateDate(prevDay:Number):Void {
	var currentDate:Date = new Date();
	var tmpMC:MovieClip;
	var currentDay:Number = currentDate.getDate();
	var currentMonth:Number = currentDate.getMonth() + 1;
	var currentYearL:Number = currentDate.getFullYear() % 100;
	var currentYearH:Number = int(currentDate.getFullYear() / 100);
	var currentWeek:Number = currentDate.getDay();

	delete currentDate;
	if(currentDay != prevDay) {
		tmpMC = mcCon.MCDateIcon;
		_global.CommonSetDigitMC(tmpMC.MCDay, currentDay);
		_global.CommonSetDigitMC(tmpMC.MCMonth, currentMonth);
		_global.CommonSetDigitMC(tmpMC.MCYear, currentYearL);
		_global.CommonSetDigitMC(tmpMC.MCYearL, currentYearL);
		_global.CommonSetDigitMC(tmpMC.MCYearH, currentYearH);
		tmpMC.MCMonthName.gotoAndStop(currentMonth);

		tmpMC = mcCon.MCInfobar;
		_global.CommonSetDigitMC(tmpMC.MCDay, currentDay);
		_global.CommonSetDigitMC(tmpMC.MCMonth, currentMonth);
		_global.CommonSetDigitMC(tmpMC.MCYearL, currentYearL);
		_global.CommonSetDigitMC(tmpMC.MCYearH, currentYearH);
		tmpMC.MCWeekDay.gotoAndStop(currentWeek + 1);
	}
}

function UpdateLCDBrightness(Void):Void {
	var displayBrightness:Number = ext_fscommand2("GetDisBrightness");

	mcCon.MCOptionIcon3.MCNum.gotoAndStop(displayBrightness + 1);
}

function UpdateTimeForcibly(Void):Void {
	var tempHour:Number;

	_global.CommonSetDigitMC(mcCon.MCWidget.MCTime.MCSecond, _global.g_curSec);
	UpdateDate(-1);
	tempHour = _global.g_curHour;
	if(ext_fscommand2("GetTim24HDisplay") == 0) {
		if(tempHour < 12) {
			mcCon.MCWidget.MCTime.MCAmPm.gotoAndStop(1);
		}
		else {
			mcCon.MCWidget.MCTime.MCAmPm.gotoAndStop(2);
			if(tempHour != 12) tempHour -= 12;
		}
	}
	_global.CommonSetDigitMC(mcCon.MCWidget.MCTime.MCHour, tempHour);
	_global.CommonSetDigitMC(mcCon.MCWidget.MCTime.MCMinute, _global.g_curMin);
}

function RegisterChangeWidgetButton(Void):Void {
	mcCon.MCWidget.MCChangeWidget.onRelease = function(Void):Void {
		widgetIndex++;
		if(widgetIndex >= MAXWIDGETS) widgetIndex = 0;

		UpdateWidget(widgetIndex);
		UpdateTimeForcibly();
	}
}

function RegisterIconEvents(Void):Void {
	var idx:Number;
	var mouseDown:Boolean = false;
	var firmwareVersion:Number = _global.GetFirmwareVersion();

	UpdateLCDBrightness();
	mcCon.MCSelect._visible = false;

	if(firmwareVersion != _global.C2_DOMESTIC_DMB)
		mcCon["MCIcon" + String(DMB)]._visible = false;

	for(idx = 0; idx < TOTALICONS; idx++) {
		mcCon["MCIcon" + String(idx)].onPress = function(Void):Void {
			if(movingPage == true) return;
			var iconIndex:Number = Number(this._name.substring(6));

			mcCon.MCSelect._visible = true;
			mcCon.MCSelect._x = this._x;
			mcCon.MCSelect._y = this._y;

			selectedItem = iconIndex;
			mouseDown = true;
		}

		mcCon["MCIcon" + String(idx)].onDragOut = function(Void):Void {
			mcCon.MCSelect._visible = false;
			mouseDown = false;
		}

		mcCon["MCIcon" + String(idx)].onRelease = function(Void):Void {
			if((movingPage == true) || (selectedItem == -1)) return;

			var iconIndex:Number = Number(this._name.substring(6));
			mouseDown = false;

			ExecuteSubMenu(iconIndex);
		}
	}

	for(idx = 0; idx < TOTALOPTIONALICONS; idx++) {
		mcCon["MCOptionIcon" + String(idx)].onPress = function(Void):Void {
			if(movingPage == true) return;

			var iconIndex:Number = Number(this._name.substring(12));

			mcCon.MCSelect._visible = true;
			mcCon.MCSelect._x = this._x;
			mcCon.MCSelect._y = this._y;

			selectedItem = iconIndex;
			mouseDown = true;
		}

		mcCon["MCOptionIcon" + String(idx)].onDragOut = function(Void):Void {
			mcCon.MCSelect._visible = false;
			mouseDown = false;
		}

		mcCon["MCOptionIcon" + String(idx)].onRelease = function(Void):Void {
			if((movingPage == true) || (selectedItem == -1)) return;

			var iconIndex:Number = Number(this._name.substring(12));
			mouseDown = false;

			ExecuteOptionalMenu(iconIndex);
		}
	}
}


//============================================================== Display Update
function DisplayHoldStatus(Void):Void {
	_root.MCHold._visible = (ext_fscommand2("GetSysHoldKey") == 1) ? true : false;
}


//============================================================== Initializer, Unloader
this.onUnload = function(Void):Void {
	RemoveMouseEvents();
	delete mouseListener;

	delete mcCon.onEnterFrame;
	delete mcTimeWidget.onEnterFrame;

	ext_fscommand2("EtcModSetWidgetMode", 0);
}

function InitializeMainMenu(Void):Void {
	_global.UpdateSystemInfo(1);
	DisplayHoldStatus();
	ext_fscommand2("EtcModSetWidgetMode", 1);

	InitializeTimer();
	RegisterIconEvents();
	InitializeMouseEvents();
	StartUpEffect();

	_global.RegisterKeyListener(KeyHandlerMainMenu);
}


//============================================================== Key handler
function KeyHandlerMainMenu(keyType:Number):Void {
	switch(keyType) {
		case KEY_PLUS_SHORT:
		case KEY_PLUS_LONG:
			ext_fscommand2("KeyComPlus");
			_global.DisplayVolume(1);
			break;

		case KEY_MINUS_SHORT:
		case KEY_MINUS_LONG:
			ext_fscommand2("KeyComMinus");
			_global.DisplayVolume(1);
			break;

		case _global.KEY_HOLD:
		case _global.KEY_DISPLAY_UPDATE:
			DisplayHoldStatus();
			break
	}
}


InitializeMainMenu();
